<template>
  <div id="NeuralNetworkScreen">
    
    <h1>{{lastAcuracy}}</h1>
    <input type="number" v-model="memoryDays"> <br>
    <button @click="resetNN()"> resetNN</button><br>
     <button @mousedown="train()">train</button>
  <button @click="log()">log</button>
      
  </div>
</template>

<script>
const DAYS = require('../assets/data/trainData.json').info;
const   NeuralNetwork =    require("../js/NeuralNetwork.js");

export default {
  name: 'NeuralNetworkScreen',
  components: {
    
    },
  data(){
    return{
       per :"",
       lastAcuracy:0,
       memoryDays:2,
       trainData:[],
       trainOutputs:[],
       NN:""
    }
  },
  methods:{
    log(){
        console.log(DAYS,this.trainData.length,this.trainOutputs.length);
        
    },
    train(){
      console.log("beginnig  to train");
      
       this.lastAcuracy = this.NN.train(this.trainData,this.trainOutputs)
      console.log("training finished");
      
    },
  transformData(){

    // aqui tratas tus datos para ver con que alimentas a tu red 
    //reinitializing vars
    this.trainData =[];
    this.trainOutputs=[];
    //dias tomados en cuenta
    const mD =  parseInt(this.memoryDays, 10);
    for (let k = 0; k < DAYS.length; k++) {
      const enterprise = DAYS[k];
      
      for (let i = 0; i < enterprise.length-mD-1; i++) {
        var lastDay = enterprise[i+mD];
        const output = ((lastDay.Close-enterprise[i+mD-1].Close)>0)?1:0;
        var input = []
        for (let j = 0; j < mD; j++) {
          const day = enterprise[i+j];
          input.push(day.Close,day.Open)
        }
        this.trainData.push(input);
        this.trainOutputs.push(output);
      }
    }
    console.log("Data Loaded");
    
  },
  initNN(){
    this.NN ={};
    const inputLength = this.trainData[0].length
    const midleLayerLength = 2;
    const outputsLength = 2
   this.NN  = new NeuralNetwork (inputLength,midleLayerLength,outputsLength);   
  },
  resetNN(){
    console.log(parseInt(this.memoryDays, 10));
    
     this.transformData()
     this.initNN()
  }
  },
  mounted(){
    this.resetNN();
  }
  
}
</script>

<style>
body {
    display: block;
    margin: 0px;
}
#NeuralNetworkScreen {
  font-family: 'Avenir', Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
}

</style>
